#!/bin/bash
# set -e

# script that starts up kubernetes cluster, and does some basic qol

sudo swapoff -a # turn off swap memory

# make cert key for join command later (gets used in init automathically)
VIP="192.168.111.10"

# put load balancer pod spec in the manifests directory
sudo docker run --network host --rm ghcr.io/kube-vip/kube-vip:main manifest pod \
--vip $VIP \
--arp \
--controlplane \
--leaderElection | sudo tee /etc/kubernetes/manifests/vip.yaml

sudo kubeadm init -v 6 --config kubeadm-config.yaml --upload-certs

if [[ $? -ne 0 ]] ; then
  # some error
  echo "Error! Stopping cluster set up"
  exit 1
fi

mkdir -p $HOME/.kube
sudo cp -f /etc/kubernetes/admin.conf $HOME/.kube/config
sudo chown $(id -u):$(id -g) $HOME/.kube/config
#
kubectl apply -f flannel.yml
kubectl taint nodes --all node-role.kubernetes.io/master-

# print join command again to clipboard and add bling (COPY NOT WORKING)
# echo "$(kubeadm token create --print-join-command)--control-plane --certificate-key $KEEY" | xclip -sel clip
exit 0
